
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <improv/improv.h>

ImprovClass improv_object_class={
	name:	"ImprovObject",
	size:	sizeof(ImprovObject),
	parent:	NULL,
};

ImprovObject *improv_object_new(ImprovClass *klass)
{
	ImprovObject *it;

	printf("new object %s size=%d\n",klass->name,klass->size);

	it=malloc(klass->size);
	memset(it,0,klass->size);

	it->klass=klass;
	it->use_count=1;

	return it;
}

ImprovObject *improv_object_clone(ImprovObject *obj)
{
	ImprovObject *it;
	ImprovClass *klass=obj->klass;

	printf("clone object %s size=%d\n",klass->name,klass->size);

	it=malloc(klass->size);
	memcpy(it,obj,klass->size);

	it->use_count=1;

	return it;
}

void __improv_object_dump(ImprovObject *obj)
{
	printf("<%p> %s\n",obj,obj->klass->name);
}

void improv_object_dump(ImprovObject *obj)
{
	void (*func)(ImprovObject *obj);

	__improv_object_dump(obj);
	func=obj->klass->dump;
	if(func)
		func(obj);
}

