
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <improv/improv.h>

ImprovClass improv_timer_class={
	name:	"ImprovTimer",
	size:	sizeof(ImprovTimer),
	parent:	&improv_object_class,
};

int improv_timer_expire(ImprovTimer *t)
{
	improv_signal_emit(IMPROV_OBJECT(t),1);

	return 0;
}

static ImprovTimer *timer_list;

static void improv_timer_list_add(ImprovTimer *timer)
{
	ImprovTimer *last=NULL,*t=timer_list;

	while(t){
		if(improv_time_compare(&t->expires,&timer->expires)<0)
			break;
		last=t;
		t=t->next;
	}
	if(!last)timer_list=timer;
	else last->next=timer;

	timer->next=t;
}

ImprovTimer *improv_timer_new(void)
{
	ImprovTimer *it;

	it=IMPROV_TIMER(improv_object_new(&improv_timer_class));

	it->armed=0;

	return 0;
}

int improv_timer_set(ImprovTimer *t,ImprovTime *time)
{
	t->expires=*time;
	
	return 0;
}

int improv_timer_arm(ImprovTimer *t)
{
	t->armed=1;

	improv_timer_list_add(t);

	return 0;
}

int improv_timer_disarm(ImprovTimer *t)
{
	t->armed=0;

	return 0;
}






int improv_time_get_current(ImprovTime *time)
{
	gettimeofday(time,NULL);

	return 0;
}

int improv_time_compare(ImprovTime *a,ImprovTime *b)
{
	if(a->tv_sec==b->tv_sec)
		return b->tv_usec-a->tv_usec;
	return b->tv_sec-a->tv_sec;
}

