
#ifndef _IMPROV_OBJECT_H
#define _IMPROV_OBJECT_H

typedef struct improv_object_struct ImprovObject;
typedef struct improv_class_struct ImprovClass;

#define IMPROV_OBJECT(a)	((ImprovObject *)(a))

extern ImprovClass improv_object_class;

struct improv_object_struct{
	unsigned int use_count;
	unsigned int flags;
	ImprovClass *klass;
	
	void *signals;
};

struct improv_class_struct{
	char *name;
	unsigned int size;
	void (*dump)(ImprovObject *);
	ImprovClass *parent;
};

ImprovObject *improv_object_new(ImprovClass *klass);
ImprovObject *improv_object_clone(ImprovObject *obj);

void __improv_object_dump(ImprovObject *obj);
void improv_object_dump(ImprovObject *obj);


#endif

