
#ifndef _IMPROV_SIGNAL_H
#define _IMPROV_SIGNAL_H

#include <improv/improv_object.h>

typedef struct improv_signal_struct ImprovSignal;
typedef int ImprovSignalFunc(ImprovObject *obj,int signal_type,void *arg);

#define IMPROV_SIGNAL(a)	((ImprovSignal *)(a))

struct improv_signal_struct{
	/* object we're connected to */
	ImprovObject *object;

	/* linked list */
	ImprovSignal *next;

	int signal_type;
	ImprovSignalFunc *func;
	void *arg;
};


int improv_signal_connect(ImprovObject *obj,int signal_type,ImprovSignalFunc
	func,void *arg);

int improv_signal_emit(ImprovObject *obj,int signal_type);

ImprovSignal *improv_signal_new(void);
void improv_signal_free(ImprovSignal *sig);

int improv_signal_marshal(ImprovObject *obj,int signal_type);
int improv_signal_marshal_one(void);



#endif

