

#ifndef _IMPROV_SOCKET_H
#define _IMPROV_SOCKET_H

#include <improv/improv_object.h>
#include <improv/improv_signal.h>
#include <improv/improv_data.h>


typedef struct improv_socket_struct ImprovSocket;

#define IMPROV_SOCKET(a)	((ImprovSocket *)(a))

extern ImprovClass improv_socket_class;

struct improv_socket_struct{
	ImprovObject object;

	ImprovSocket *from;
	ImprovSocket *to;

	ImprovData *next;
	ImprovData *prev;
	unsigned int n_data;
};


/* create a new socket */
ImprovSocket *improv_socket_new(void);

/* read from a socket, and request if none available */
int improv_socket_read(ImprovSocket *sock,ImprovData **data,int request);

/* look at available data */
int improv_socket_peek(ImprovSocket *sock,ImprovData **data);

/* write to a writable socket */
int improv_socket_write(ImprovSocket *sock,ImprovData *data);

/* write to a writable socket, take over ownership of malloc'd block */
int improv_socket_write_nocopy(ImprovSocket *sock,ImprovData *data);


#endif

