
#ifndef _IMPROV_TIMER_H
#define _IMPROV_TIMER_H

#include <improv/improv_object.h>
#include <sys/time.h>
#include <unistd.h>

typedef struct improv_timer_struct ImprovTimer;
typedef struct timeval ImprovTime;

#define IMPROV_TIMER(a)		((ImprovTimer *)(a))

struct improv_timer_struct{
	ImprovObject object;

	ImprovTime expires;
	int armed;

	ImprovTimer *next;
};


ImprovTimer *improv_timer_new(void);

int improv_timer_set(ImprovTimer *timer,ImprovTime *time);

int improv_timer_arm(ImprovTimer *timer);
int improv_timer_disarm(ImprovTimer *timer);

int improv_timer_expire(ImprovTimer *timer);

int improv_time_get_current(ImprovTime *time);
int improv_time_compare(ImprovTime *a,ImprovTime *b);


#endif

